#ifndef COMMAND_BASE_H
#define COMMAND_BASE_H

#include <memory>
#include <string>

#include <Commands/Command.h>

#include "OI.h"
#include "Subsystems/Drive.h"
#include "Subsystems/FuelHandler.h"
#include "Subsystems/GearPickup.h"
#include "Subsystems/Goat.h"
#include "Subsystems/Vision.h"

class CommandBase: public frc::Command {
public:
	CommandBase(const std::string& name);
	CommandBase() = default;

	static std::unique_ptr<Drive> drive;
	static std::unique_ptr<FuelHandler> fuelHandler;
	static std::unique_ptr<GearPickup> gearPickup;
	static std::unique_ptr<Goat> goat;
	static std::unique_ptr<Vision> vision;

	static std::unique_ptr<OI> oi;
};

#endif  // COMMAND_BASE_H
