#include "CmdAutoRotate.h"
#include "Robot.h"

CmdAutoRotate::CmdAutoRotate(double angle, bool useAbsolute, double maxRotate, int msecTimeout, Drive::DriveWheels wheels,
		                     bool ignoreTimeout, bool* cancel) {
	Requires(drive.get());

	m_angle = angle;
	m_useAbsolute = useAbsolute;
	m_maxRotate = maxRotate;
	m_msecTimeout = msecTimeout;
	m_ignoreTimeout = ignoreTimeout;
	m_cancel = cancel;
	m_driveWheels = wheels;
}

void CmdAutoRotate::Initialize() {
	if(m_cancel != nullptr && *m_cancel == true) return;
	drive->InitAutoRotate(m_angle, m_useAbsolute, m_maxRotate, m_msecTimeout, m_driveWheels);
}

void CmdAutoRotate::Execute() {
}

bool CmdAutoRotate::IsFinished() {
	bool isFinished = false;

	switch(drive->GetAutoState()){
		case Drive::asFinished:
			isFinished = true;
			break;
		case Drive::asTimedOut:
			if(!m_ignoreTimeout) *m_cancel = true;
			isFinished = true;
			break;
		default:;
	}
	return isFinished;
}

void CmdAutoRotate::End() {
	drive->SetDriveMode(Drive::dmAutoDone);
}

void CmdAutoRotate::Interrupted() {
	drive->SetDriveMode(Drive::dmDriveRotate);
	Robot::robotLog->Write("Drive:   Auto Rotate Interrupted");
}
