#ifndef CmdAutoRotate_H
#define CmdAutoRotate_H

#include "../CommandBase.h"
#include "../Subsystems/Drive.h"

class CmdAutoRotate : public CommandBase {
public:
	CmdAutoRotate(double angle, bool useAbsolute, double maxRotate, int msecTimeout, Drive::DriveWheels wheels, bool ignoreTimeout, bool* cancel = nullptr);
	void Initialize();
	void Execute();
	bool IsFinished();
	void End();
	void Interrupted();

private:
	double		m_angle;
	bool		m_useAbsolute;
	double		m_maxRotate;
	int			m_msecTimeout;
	bool		m_ignoreTimeout;
	bool*		m_cancel;
	Drive::DriveWheels m_driveWheels;
};

#endif  // CmdAutoRotate_H
