#include "CmdAutoStrafe.h"
#include "Robot.h"

CmdAutoStrafe::CmdAutoStrafe(double distance, bool useAbsolute, double maxStrafe, int msecTimeout,
		                     bool ignoreTimeout, bool* cancel) {
	Requires(drive.get());

	m_distance = distance;
	m_useAbsolute = useAbsolute;
	m_maxStrafe = maxStrafe;
	m_msecTimeout = msecTimeout;
	m_ignoreTimeout = ignoreTimeout;
	m_cancel = cancel;
}

void CmdAutoStrafe::Initialize() {
	if(m_cancel != nullptr && *m_cancel == true) return;
	drive->InitAutoStrafe(m_distance, m_useAbsolute, m_maxStrafe, m_msecTimeout);
}

void CmdAutoStrafe::Execute() {
}

bool CmdAutoStrafe::IsFinished() {
	bool isFinished = false;

	switch(drive->GetAutoState()){
		case Drive::asFinished:
			isFinished = true;
			break;
		case Drive::asTimedOut:
			if(!m_ignoreTimeout) *m_cancel = true;
			isFinished = true;
			break;
		default:;
	}
	return isFinished;
}

void CmdAutoStrafe::End() {
	drive->SetDriveMode((Drive::dmAutoDone));
}

void CmdAutoStrafe::Interrupted() {
	drive->SetDriveMode(Drive::dmDriveRotate);
	Robot::robotLog->Write("Drive:   Auto Strafe Interrupted");
}
