#include "CmdFindTarget.h"
#include "Robot.h"

CmdFindTarget::CmdFindTarget(double angleBias, bool cancelIfNone, bool* cancel) {
	m_angleBias = angleBias;
	m_cancelIfNone = cancelIfNone;
	m_cancel = cancel;
	m_finished = false;
}

void CmdFindTarget::Initialize() {
	if (m_cancel != nullptr && *m_cancel == true) {
		m_finished = true;
	} else {
		m_finished = false;
		vision->FindTarget(m_angleBias);
	}
}

void CmdFindTarget::Execute() {
	if (!m_finished) {
		switch (vision->GetSearchState()) {
			case Vision::ssNoTarget:
				if (m_cancelIfNone && m_cancel != nullptr) *m_cancel = true;
				m_finished = true;
				break;
			case Vision::ssLooking:
				break;
			default:
				m_finished = true;
		}
	}
}

bool CmdFindTarget::IsFinished() {
	return m_finished;
}

void CmdFindTarget::End() {
}

void CmdFindTarget::Interrupted() {
}
