#include "CmdLiftAlign.h"

CmdLiftAlign::CmdLiftAlign() {
	Requires(drive.get());

	m_isFinished = false;
}

void CmdLiftAlign::Initialize() {
	double curAngle = drive->GetGyroAngle();

	Robot::dashboard->SetRobotValue(Robot::rvLiftAlign, 0);

	if(curAngle > 335 && curAngle < 25){
		drive->InitAutoRotate(0, true, 0.6, 0, Drive::dwAll);
	}else if(curAngle > 275 && curAngle < 325){
		drive->InitAutoRotate(300, true, 0.6, 0, Drive::dwAll);
	}else if(curAngle > 35 && curAngle < 85){
		drive->InitAutoRotate(60, true, 0.6, 0, Drive::dwAll);
	}else{
		m_isFinished = true;
	}
}

void CmdLiftAlign::Execute() {
	if(!m_isFinished){
		m_isFinished = (drive->GetAutoState() == Drive::asFinished);
		if(m_isFinished) Robot::dashboard->SetRobotValue(Robot::rvLiftAlign, 1);
	}
}

bool CmdLiftAlign::IsFinished() {
	return m_isFinished;
}

void CmdLiftAlign::End() {
	drive->SetDriveMode(Drive::dmDriveRotate);
}

void CmdLiftAlign::Interrupted() {
}
