#include "GrpAutoBlueShoot.h"
#include "CmdSetFuelShooter.h"
#include "CmdSetFuelIntake.h"
#include "CmdAutoRotate.h"
#include "CmdAutoDrive.h"

GrpAutoBlueShoot::GrpAutoBlueShoot(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new CmdSetFuelIntake(FuelHandler::imIn));
	AddSequential(new CmdSetFuelShooter(true));
	AddSequential(new WaitCommand(8));
	AddSequential(new CmdSetFuelShooter(false));
	AddSequential(new CmdSetFuelIntake(FuelHandler::imOff));
	AddSequential(new CmdAutoRotate(30, false, 0.6, 2000, Drive::dwPivotRight, false, &m_cancel));
	AddSequential(new CmdAutoDrive(90, false, 0.4, 3000, false, false, &m_cancel));
}

bool GrpAutoBlueShoot::IsFinished() {
	if (m_cancel){
		m_cancel = false;
		return true;
	}else{
		return CommandGroup::IsFinished();
	}
}
