#include <Commands/GrpAutoLeftLift.h>
#include "CmdAutoDrive.h"
#include "CmdAutoRotate.h"
#include "CmdGearPlace.h"
#include "CmdSetGearArm.h"
#include "CmdFindTarget.h"

GrpAutoLeftLift::GrpAutoLeftLift(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new CmdAutoDrive(-62, false, 0.4, 3000, false, false, &m_cancel));    // -75, -65
	AddSequential(new CmdAutoRotate(60, false, 0.6, 3000, Drive::dwAll, false, &m_cancel));
	AddSequential(new WaitCommand(0.25));
	AddSequential(new CmdFindTarget(0, true, &m_cancel));
	AddSequential(new CmdAutoDrive(-90, false, 0.4, 3000, true, true, &m_cancel));
	AddSequential(new CmdGearPlace(40, &m_cancel));
	AddSequential(new CmdSetGearArm(false));
}

bool GrpAutoLeftLift::IsFinished()
{
	if (m_cancel){
		m_cancel = false;
		return true;
	}else{
		return CommandGroup::IsFinished();
	}
}
