#include "GrpAutoRedShoot.h"
#include "CmdSetFuelShooter.h"
#include "CmdSetFuelIntake.h"
#include "CmdAutoRotate.h"
#include "CmdAutoDrive.h"
#include "CmdFindTarget.h"
#include "CmdGearPlace.h"
#include "CmdSetGearArm.h"

GrpAutoRedShoot::GrpAutoRedShoot(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new CmdSetFuelIntake(FuelHandler::imIn));
	AddSequential(new CmdSetFuelShooter(true));
	AddSequential(new WaitCommand(6.5));
	AddSequential(new CmdSetFuelShooter(false));
	AddSequential(new CmdSetFuelIntake(FuelHandler::imOff));
	AddSequential(new CmdAutoRotate(-55, false, 0.6, 2000, Drive::dwPivotLeft, false, &m_cancel));	// 45
//	AddSequential(new CmdAutoDrive(-90, false, 0.4, 3000, false, false, &m_cancel));
	AddSequential(new CmdAutoDrive(-66, false, 0.4, 3000, false, false, &m_cancel));
	AddSequential(new CmdAutoRotate(-45, false, 0.6, 3000, Drive::dwAll, false, &m_cancel));		// 60
	AddSequential(new WaitCommand(0.25));
	AddSequential(new CmdFindTarget(-2.0, true, &m_cancel));
	AddSequential(new CmdAutoDrive(-80, false, 0.4, 3000, true, true, &m_cancel));	// -72
	AddSequential(new CmdGearPlace(40, &m_cancel));
	AddSequential(new CmdSetGearArm(false));
}

bool GrpAutoRedShoot::IsFinished() {
	if (m_cancel){
		m_cancel = false;
		return true;
	}else{
		return CommandGroup::IsFinished();
	}
}
