#include "GrpAutoRightLift.h"
#include "CmdAutoDrive.h"
#include "CmdAutoRotate.h"
#include "CmdFindTarget.h"
#include "CmdGearPlace.h"
#include "CmdSetGearArm.h"

GrpAutoRightLift::GrpAutoRightLift(double wait) {
	m_cancel = false;

	AddSequential(new WaitCommand(wait));
	AddSequential(new CmdAutoDrive(-66, false, 0.4, 3000, false, false, &m_cancel));	// -66, -76, -66
	AddSequential(new CmdAutoRotate(-60, false, 0.6, 3000, Drive::dwAll, false, &m_cancel));
	AddSequential(new WaitCommand(0.25));
	AddSequential(new CmdFindTarget(-2.0, true, &m_cancel));
	AddSequential(new CmdAutoDrive(-80, false, 0.4, 3000, true, true, &m_cancel));	// -72
	AddSequential(new CmdGearPlace(40, &m_cancel));
	AddSequential(new CmdSetGearArm(false));
}

bool GrpAutoRightLift::IsFinished()
{
	if (m_cancel){
		m_cancel = false;
		return true;
	}else{
		return CommandGroup::IsFinished();
	}
}
