#include "OI.h"
#include "Commands\CmdSetDriveMode.h"
#include "Commands\CmdSetGearRollers.h"
#include "Commands\CmdSetFuelShooter.h"
#include "Commands\CmdSetFuelIntake.h"
#include "Commands\CmdSetFuelLegs.h"
#include "Commands\CmdSetGearArm.h"
#include "Commands\CmdGearPickup.h"
#include "Commands\CmdGearPlace.h"
#include "Commands\CmdSetAirVent.h"
#include "Commands\CmdLiftAlign.h"
#include "Commands\CmdFindTarget.h"

#include <WPILib.h>

OI::OI() {
	m_driveJoystick = new Joystick(0);
	m_opJoystick = new Joystick(1);

	// Drive Joystick Buttons

	m_driveStrafe = new JoystickButton(m_driveJoystick, 1);
	m_driveStrafe->WhenPressed(new CmdSetDriveMode(Drive::dmDriveStrafe));
	m_driveStrafe->WhenReleased(new CmdSetDriveMode(Drive::dmDriveRotate));

	m_strafe = new JoystickButton(m_driveJoystick, 2);
	m_strafe->WhenPressed(new CmdSetDriveMode(Drive::dmStrafe));
	m_strafe->WhenReleased(new CmdSetDriveMode(Drive::dmDriveRotate));

	m_liftAlign = new JoystickButton(m_driveJoystick, 3);
	m_strafe->WhenPressed(new CmdLiftAlign());
	m_strafe->WhenReleased(new CmdSetDriveMode(Drive::dmDriveRotate));

	m_legsUpLeft = new JoystickButton(m_driveJoystick, 6);
	m_legsUpLeft->WhenPressed(new CmdSetFuelLegs(FuelHandler::flLeft,false));

	m_legsDownLeft = new JoystickButton(m_driveJoystick, 7);
	m_legsDownLeft->WhenPressed(new CmdSetFuelLegs(FuelHandler::flLeft,true));

	m_rotateGear = new JoystickButton(m_driveJoystick, 8);
	m_rotateGear->WhenPressed(new CmdFindTarget(0, false));

	m_legsDownRight = new JoystickButton(m_driveJoystick, 10);
	m_legsDownRight->WhenPressed(new CmdSetFuelLegs(FuelHandler::flRight, true));

	m_legsUpRight = new JoystickButton(m_driveJoystick, 11);
	m_legsUpRight->WhenPressed(new CmdSetFuelLegs(FuelHandler::flRight,false));

	// Operator Joystick Buttons

	m_gearPlace = new JoystickButton(m_opJoystick, 1);
	m_gearPlace->WhenPressed(new CmdGearPlace(30));

	m_gearEject = new JoystickButton(m_opJoystick, 2);
	m_gearEject->WhenPressed(new CmdSetGearRollers(GearPickup::rmEject));

	m_gearPickup = new JoystickButton(m_opJoystick, 3);
	m_gearPickup->WhenPressed(new CmdGearPickup());

	m_gearUp = new JoystickButton(m_opJoystick, 4);
	m_gearUp->WhenPressed(new CmdSetGearArm(false));

	m_gearDown = new JoystickButton(m_opJoystick, 5);
	m_gearDown->WhenPressed(new CmdSetGearArm(true));

	m_shooterOn = new JoystickButton(m_opJoystick, 6);
	m_shooterOn->WhenPressed(new CmdSetFuelShooter(true));

	m_shooterOff = new JoystickButton(m_opJoystick, 7);
	m_shooterOff->WhenPressed(new CmdSetFuelShooter(false));

	m_openAirVent = new JoystickButton(m_opJoystick, 8);
	m_openAirVent->WhenPressed(new CmdSetAirVent(true));

	m_closeAirVent = new JoystickButton(m_opJoystick, 9);
	m_closeAirVent->WhenPressed(new CmdSetAirVent(false));

	m_fuelIntakeOff = new JoystickButton(m_opJoystick, 10);
	m_fuelIntakeOff->WhenPressed(new CmdSetFuelIntake(FuelHandler::imOff));

	m_fuelIntakeIn = new JoystickButton(m_opJoystick, 11);
	m_fuelIntakeIn->WhenPressed(new CmdSetFuelIntake(FuelHandler::imIn));
}

double OI::ApplyDeadBand(double joyValue, double deadBand) {
	if(fabs(joyValue) < deadBand)	return 0;
	else if(joyValue > 0) 			return ((joyValue - deadBand) / (1 - deadBand));
	else 							return ((joyValue + deadBand) / (1 - deadBand));
}

double OI::GetDriveYAxis() {
	return OI::ApplyDeadBand(m_driveJoystick->GetY(), 0.07);
}

double OI::GetDriveZAxis() {
	return OI::ApplyDeadBand(m_driveJoystick->GetZ(), 0.15);
}

double OI::GetDriveXAxis() {
	return OI::ApplyDeadBand(m_driveJoystick->GetX(), 0.07);
}

double OI::GetOpYAxis() {
	return OI::ApplyDeadBand(m_opJoystick->GetY(), 0.07);
}

