#ifndef OI_H
#define OI_H

#include "WPILib.h"

class OI {
public:
	OI();

	double ApplyDeadBand(double joyValue, double deadBand);
	double GetDriveYAxis();
	double GetDriveZAxis();
	double GetDriveXAxis();

	double GetOpYAxis();

private:
	Joystick*		m_driveJoystick;
	Joystick*		m_opJoystick;

	JoystickButton*	m_driveStrafe;			//drive and strafe
	JoystickButton*	m_strafe;				//only strafe
	JoystickButton*	m_liftAlign;
	JoystickButton* m_legsDownRight;		//right legs down
	JoystickButton* m_legsUpRight;			//right legs up
	JoystickButton* m_legsDownLeft;			//left legs down
	JoystickButton* m_legsUpLeft;			//left legs up
	JoystickButton* m_rotateGear;

	JoystickButton* m_gearPickup;			//gear pickup down and rollers are in
	JoystickButton* m_gearPlace;			//ejects gear, puts gear pickup down, and moves away
	JoystickButton* m_gearEject;			//puts pickup down and rollers out then rollers in
	JoystickButton* m_gearDown;				//pickup down and rollers off
	JoystickButton* m_gearUp;				//pickup up and rollers off
	JoystickButton* m_shooterOff;			//shooter off
	JoystickButton* m_shooterOn;			//shooter on
	JoystickButton* m_fuelIntakeOff;		//turns off intake
	JoystickButton* m_fuelIntakeIn;			//turns on intake
	JoystickButton* m_openAirVent;
	JoystickButton* m_closeAirVent;

};

#endif  // OI_H
