#ifndef PIDCONTROL_H_
#define PIDCONTROL_H_

class PIDControl {
public:
	PIDControl();
	~PIDControl();

	double	Calculate(double input, bool showResults);
	void	Reset();
	void 	SetCoefficient(char kWhich, double errorThreshold, double kAbove, double kBelow);
	void	SetInputRange(double minimumInput, double maximumInput);
	void	SetOutputRange(double minimumOutput, double maximumOutput);
	void	SetSetpoint(double setpoint);

private:
	struct Coefficient {
		double		threshold;
		double		kAbove;
		double		kBelow;
		double		kNow;
	};

	Coefficient	m_P;
	Coefficient m_I;
	Coefficient m_D;
	Coefficient m_E;

	double	m_maximumOutput;
	double 	m_minimumOutput;
	double	m_maximumInput;
	double	m_minimumInput;
	double	m_prevError;
	bool	m_prevReset;
	double	m_totalError;
	double	m_setpoint;
};

#endif







