#ifndef FuelHandler_H
#define FuelHandler_H

#include <Commands/Subsystem.h>
#include "WPILib.h"
#include "CANTalon.h"

class FuelHandler : public Subsystem {

public:
	typedef enum {rsOff, rsForward, rsReverse, rsOn} RelayState;
	typedef enum {flLeft, flRight} FuelLegs;
	typedef enum {imOff, imIn, imOut} IntakeMode;

	FuelHandler();
	void InitDefaultCommand();
	void InitFuelHandler();
	void Periodic();
	void SetAgitator(RelayState state);
	void SetAuger(RelayState state);
	void SetChurner(RelayState state);
	void SetDashboardValues();
	void SetIntakeMode(IntakeMode mode);
	void SetLegs(FuelLegs legs, bool legDown);
	void SetShooter(bool shooterOn);

private:
	Relay*					m_fuelAgitator;
	Relay*					m_fuelAuger;
	VictorSP*				m_fuelChurner;
	VictorSP*				m_fuelIntake;
	CANTalon*				m_highShooter;
	CANTalon*				m_lowShooter;
	PowerDistributionPanel* m_panel;

	Solenoid*   			m_leftLeg;
	Solenoid*   			m_rightLeg;

	RelayState		m_agitatorState;
	RelayState    	m_augerState;
	RelayState		m_churnerState;
	IntakeMode		m_intakeMode;
	bool 			m_leftLegDown;
	char			m_log[100];
	bool 			m_rightLegDown;
	int 			m_shooterDelay;
	bool			m_shooterOn;
};

#endif  // FuelHandler_H
