#ifndef GearPickup_H
#define GearPickup_H

#include "WPILib.h"
#include <Commands/Subsystem.h>

class GearPickup : public Subsystem {
public:
	typedef enum {rmOff, rmIn, rmOut, rmPlace, rmEject, rmEjectWait, rmRollGear} RollerMode;

	GearPickup();

	bool		GetGearPosition();
	void 		InitDefaultCommand();
	void 		InitGearPickup();
	void 		Periodic();
	void		SetAirVent(bool ventOpen);
	void		SetDashboardValues();
	void 		SetGearPosition(bool gearDown);
	void 		SetRollerMode(RollerMode mode);

private:

	Solenoid*		m_airVent;
	Solenoid* 		m_arm;
	Compressor*		m_compressor;
	DigitalInput*   m_gearSensor;
	VictorSP* 		m_rollerL;
	VictorSP* 		m_rollerR;

	int 			m_ejectCount;
	bool		 	m_gearDown;
	char			m_log[100];
	RollerMode  	m_rollerMode;
	double			m_rollerPWM;
	bool			m_ventOpen;

	std::string	RollerModeName(int index);
};

#endif  // GearPickup_H
