#include "Goat.h"
#include "../Robot.h"
#include "../CommandBase.h"

Goat::Goat() : Subsystem("Goat") {
	m_goator  	 = nullptr;
	m_panel   	 = nullptr;
}

void Goat::InitDefaultCommand() {
}

void Goat::InitGoat() {
	m_goator = new VictorSP(Robot::pwmGoator);
	m_panel  = new PowerDistributionPanel(0);
}

void Goat::Periodic(bool reverse) {
	double speed = CommandBase::oi->GetOpYAxis();

	if (reverse) {
		if (speed >= 0) speed = 0;
		m_goator->Set(speed * Robot::dashboard->GetDashValue(Robot::dvGoatDirection));
	} else {
		if (speed <= 0) speed = 0;
		m_goator->Set(speed * Robot::dashboard->GetDashValue(Robot::dvGoatDirection));
	}

	SetDashboardValues();
}

void Goat::SetDashboardValues() {
	Robot::dashboard->SetRobotValue(Robot::rvGoatAmps, m_panel->GetCurrent(9));
}
