#ifndef Vision_H
#define Vision_H

#include <WPILib.h>
#include <Commands/Subsystem.h>
#include <opencv2/objdetect/objdetect.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/core/core.hpp>
#include <opencv2/features2d.hpp>


class Vision : public Subsystem {
public:
	typedef enum {ssDone, ssLooking, ssNoTarget, ssTargetFound} SearchState;

	Vision();
	void 		InitDefaultCommand();
	void		FindTarget(double angleBias = 0);
	bool		GetCameraImage(cv::Mat& image);
	SearchState GetSearchState();
	double		GetTargetAngle();
	double		GetTargetDistance();
	void		InitVision();
	void		SearchResults(bool targetFound, double targetAngle, double targetDistance);
	static void TargetSearch(Vision* host);

private:
	double			m_angleBias;
	char  			m_log[100];
	SearchState		m_searchState;
	cs::CvSink		m_sink;
	double   		m_targetAngle;
	double			m_targetDistance;
	std::thread*	m_task;
};

#endif  // Vision_H
